function dataout = time_differentiate(datain, samprate)

% Calculate the time differentiate of the input data.
% usage: dataout = time_differentiate(datain, samprate)
% The output is a column vector.
% Since the differentiate will reduce one datum,
% the last datum output is the repetition of the penultimate datum.
%
% Yuechu Wu
% 12131066@mail.sustech.edu.cn
% 2022-09-29

if isrow(datain)
    datain = datain';
end

temp = diff(datain) * samprate;
dataout = [temp;temp(end)];

end